package eu.mhsl.craftattack.spawn.appliances.tablist;

import eu.mhsl.craftattack.spawn.Main;
import eu.mhsl.craftattack.spawn.appliance.Appliance;
import eu.mhsl.craftattack.spawn.util.ComponentUtil;
import eu.mhsl.craftattack.spawn.util.RainbowComponent;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.util.Ticks;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;

import java.util.List;


public class Tablist extends Appliance {
    private final int refreshRate = Ticks.TICKS_PER_SECOND * 3;

    private final RainbowComponent serverName = new RainbowComponent(" CraftAttack 6 ", 7, 3);
    private final Component hostName = Component.text("mhsl.eu").color(NamedTextColor.GOLD);
    @Override
    public void onEnable() {
        Runnable updateAll = () -> Bukkit.getOnlinePlayers().forEach(this::update);
        Bukkit.getScheduler().runTaskTimerAsynchronously(Main.instance(), updateAll, refreshRate, refreshRate);
    }

    public void update(Player player) {
        updateHeader(player);
        updateFooter(player);
    }

    public void updateHeader(Player player) {
        player.sendPlayerListHeader(
                Component.newline()
                        .append(serverName.getRainbowState())
                        .appendNewline()
                        .append(hostName)
                        .appendNewline()
                        .appendNewline()
                        .append(ComponentUtil.getFormattedMSPT())
                        .appendNewline()
                        .appendNewline()
                        .append(ComponentUtil.getFormattedPing(player))
                        .appendNewline()
        );
    }

    public void updateFooter(Player player) {
        player.sendPlayerListFooter(
                Component.text()
                        .appendNewline()
                        .append(Component.text(" Um einen Spieler zu melden, verwende ", NamedTextColor.GRAY))
                        .appendNewline()
                        .append(Component.text("/report <spieler> <grund>", NamedTextColor.GOLD))
                        .appendNewline()
        );
    }

    @Override
    protected @NotNull List<Listener> eventHandlers() {
        return List.of(new TablistListener());
    }
}
